
package cz.cuni.mff.corrector.execution;

import cz.cuni.mff.corrector.corrector.Corrector;
import cz.cuni.mff.corrector.repair.Repair;

/**
 * Auxiliary class used for concurrent fetching of repairs and tasks.
 * 
 * @author Martin Svoboda
 */
public class Wrapper {
    
    // -------------------------------------------------------------------------
    
    
    /**
     * Optional reference to the associated intent repair structure.
     */
    public final Repair repairReference;
    
    /**
     * Optional reference to the associated task structure.
     */
    public final Task taskReference;
    
    
    // -------------------------------------------------------------------------
    
    
    /**
     * Creates a new wrapper instance from the provided repair.
     * @param repairReference Associated repair structure reference.
     */
    public Wrapper(Repair repairReference) {
        this.repairReference = repairReference;
        this.taskReference = null;
    }
    
    /**
     * Creates a new wrapper instance from the provided task.
     * @param taskReference Associated task structure reference.
     */
    public Wrapper(Task taskReference) {
        this.repairReference = null;
        this.taskReference = taskReference;
    }
    
    
    // -------------------------------------------------------------------------
    
}
