
package cz.cuni.mff.corrector.expression;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * Regular subexpression for empty expression.
 *
 * @author Martin Svoboda
 */
public class ExpressionEmpty extends Expression {

    // -------------------------------------------------------------------------


    /**
     * Creates an instance of the empty regular subexpression.
     */
    protected ExpressionEmpty() { }


    public ExpressionEmpty duplicateExpression() {
        return new ExpressionEmpty();
    }


    // -------------------------------------------------------------------------


    public Type getType() {
        return Type.EMPTY;
    }


    public String serializeExpression() {
        return TOKEN_RE_EMPTY;
    }


    public Set<String> getSymbols() {
        return new HashSet<String>();
    }

    
    protected void markSymbols(Provider provider) { }


    // -------------------------------------------------------------------------


    public boolean resolveEmpty() {
        this.allowsEmpty = true;
        return this.allowsEmpty;
    }

    public Set<String> resolveFirst() {
        Set<String> symbols = new HashSet<String>();
        return symbols;
    }

    public Set<String> resolveLast() {
        Set<String> symbols = new HashSet<String>();
        return symbols;
    }

    public Map<String, Set<String>> resolveFollow() {
        Map<String, Set<String>> mapping = new HashMap<String, Set<String>>();
        return mapping;
    }


    // -------------------------------------------------------------------------

}
