
package cz.cuni.mff.corrector.expression;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * Regular subexpression for standard symbol.
 *
 * @author Martin Svoboda
 */
public class ExpressionSymbol extends Expression {

    // -------------------------------------------------------------------------


    /**
     * Symbol name.
     */
    private String symbolName;


    // -------------------------------------------------------------------------


    /**
     * Creates an instance of the trivial regular subexpression.
     * @param symbolName Symbol name.
     */
    protected ExpressionSymbol(String symbolName) {
        this.symbolName = symbolName;
    }


    public ExpressionSymbol duplicateExpression() {
        return new ExpressionSymbol(new String(this.symbolName));
    }


    // -------------------------------------------------------------------------


    public Type getType() {
        return Type.SYMBOL;
    }


    public String serializeExpression() {
        return this.symbolName;
    }


    public Set<String> getSymbols() {
        Set<String> symbols = new HashSet<String>();
        symbols.add(this.symbolName);
        return symbols;
    }


    protected void markSymbols(Provider provider) {
        this.symbolName =
            this.symbolName + TOKEN_MS_MARK + provider.generateValue();
    }


    // -------------------------------------------------------------------------


    public boolean resolveEmpty() {
        this.allowsEmpty = false;
        return this.allowsEmpty;
    }

    public Set<String> resolveFirst() {
        Set<String> symbols = new HashSet<String>();
        symbols.add(symbolName);
        return symbols;
    }

    public Set<String> resolveLast() {
        Set<String> symbols = new HashSet<String>();
        symbols.add(symbolName);
        return symbols;
    }

    public Map<String, Set<String>> resolveFollow() {
        Map<String, Set<String>> mapping = new HashMap<String, Set<String>>();
        return mapping;
    }


    // -------------------------------------------------------------------------

}
