
package cz.cuni.mff.corrector.instruction;

import cz.cuni.mff.corrector.edit.EditRemoveLeaf;
import cz.cuni.mff.corrector.tree.Position;

/**
 * Repairing instruction remove leaf.
 *
 * @author Martin Svoboda
 */
public class InstructionRemoveLeaf extends Instruction {

    // -------------------------------------------------------------------------


    /**
     * Creates a new instance of a remove leaf instruction.
     */
    public InstructionRemoveLeaf() { }


    // -------------------------------------------------------------------------


    public Type getInstructionType() {
        return Type.REMOVE_LEAF;
    }

    public int getInstructionCost() {
        return COST_UNIT;
    }

    public String getTitleString() {
        return "removeLeaf()";
    }


    // -------------------------------------------------------------------------


    public EditRemoveLeaf generateEditOperation() {
        return new EditRemoveLeaf(this, new Position(0));
    }


    // -------------------------------------------------------------------------

}
