
package cz.cuni.mff.corrector.instruction;

import cz.cuni.mff.corrector.edit.EditRemoveNode;
import cz.cuni.mff.corrector.tree.Position;

/**
 * Repairing instruction remove node.
 *
 * @author Martin Svoboda
 */
public class InstructionRemoveNode extends Instruction {

    // -------------------------------------------------------------------------


    /**
     * Creates a new instance of a remove node instruction.
     */
    public InstructionRemoveNode() { }


    // -------------------------------------------------------------------------


    public Type getInstructionType() {
        return Type.REMOVE_NODE;
    }

    public int getInstructionCost() {
        return COST_UNIT;
    }

    public String getTitleString() {
        return "removeNode()";
    }


    // -------------------------------------------------------------------------


    public EditRemoveNode generateEditOperation() {
        return new EditRemoveNode(this, new Position(0));
    }


    // -------------------------------------------------------------------------

}
