
package cz.cuni.mff.corrector.repair;

import cz.cuni.mff.corrector.instruction.Instruction;
import cz.cuni.mff.corrector.instruction.InstructionRenameLabel;
import cz.cuni.mff.corrector.intent.Intent;
import java.util.ArrayList;
import java.util.List;

/**
 * Node repair for rename subtree correction intent.
 *
 * @author Martin Svoboda
 */
public class NodeRepairRenameSubtree extends NodeRepair {

    // -------------------------------------------------------------------------


    /**
     * Reference to the associated rename label repairing instruction.
     */
    private InstructionRenameLabel nodeInstruction;


    // -------------------------------------------------------------------------


    /**
     * Creates a new instance of a rename subtree node repair.
     * @param nodeInstruction Reference to the prepared defining instruction.
     */
    public NodeRepairRenameSubtree(InstructionRenameLabel nodeInstruction) {
        this.nodeInstruction = nodeInstruction;
    }


    // -------------------------------------------------------------------------


    public List<Instruction> getInstructionsList() {
        List<Instruction> instructionSequence = new ArrayList<Instruction>(1);
        instructionSequence.add(this.nodeInstruction);
        return instructionSequence;
    }


    public int getRepairCost() {
        return this.nodeInstruction.getInstructionCost();
    }
    

    // -------------------------------------------------------------------------


    public Intent.Type getIntentType() {
        return Intent.Type.RENAME;
    }


    // -------------------------------------------------------------------------

}
